 import javax.swing.JFrame;
   import javax.swing.*;
   import java.awt.event.*;
   import javax.swing.JMenuItem;
   import java.awt.*;
   import javax.swing.JPanel;
   import java.awt.MouseInfo;
	import javax.swing.JMenuBar;
	import java.io.InputStream;
import java.io.OutputStream;
import gnu.io.CommPortIdentifier; 
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent; 
import gnu.io.SerialPortEventListener; 
import java.util.Enumeration;

   public class PhysicsLab {
      public static void main(String[] args) {
         PhysicsLabFrame labFrame = new PhysicsLabFrame();
         labFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
         labFrame.setVisible(true);
      }
   }

   class PhysicsLabFrame extends JFrame {
	    
		 SerialTest main = new SerialTest();
		 JMenu subMenu1;
    	 JMenuItem menuItem1, menuItem2;
    	 
		 EnergyPlotPanel plotPanel;
	 
      public PhysicsLabFrame() {
			int r = 0;
			main.initialize();
			System.out.println("Puerto habilitado");
         setTitle("Arduino");
			setResizable(true);
         setSize(MyWorld.WIDTH, MyWorld.HEIGHT+50);
         MyWorld world = new MyWorld();
		 /**************************/
		 SerialTest main = new SerialTest();
		 main.initialize();
		 System.out.println("Started");
		 
		 setLayout(new BorderLayout());
		 /**************************/
         PhysicsLabPanel labPanel = new PhysicsLabPanel(world);
		 plotPanel = new EnergyPlotPanel(world, main);                     
		 /***********************************/
		 JScrollPane scrollPane = new JScrollPane(labPanel);
		 ToolBar toolBar = new ToolBar(world, main, this);
		 /***********************************/
      	//setLayout(new GridLayout(1,2)); 
		/***********************************/
		add(toolBar, BorderLayout.WEST);
		add(scrollPane, BorderLayout.CENTER);
		/************************************/
         //add(labPanel); 
         world.setPanel(labPanel);  
			world.setPanel(plotPanel); 
			world.setSerial(main); 
         ElementMenuListener cListener = new ElementMenuListener(world);
         WorldControlMenuListener wcListener = new WorldControlMenuListener(world);
			FrameControlMenuListener fcListener = new FrameControlMenuListener(this, plotPanel);
         MouseListener mListener = new MouseListener(world,labPanel);
			JMenuBar menuBar = createLabMenuBar(cListener, wcListener, fcListener, mListener);
         setJMenuBar(menuBar);
      }
   
		private JMenuBar createLabMenuBar(ElementMenuListener cl, WorldControlMenuListener wl, FrameControlMenuListener fc, MouseListener m1) {         JMenuBar mb = new JMenuBar();
         JMenu menu = new JMenu ("Element");
         mb.add(menu);
         JMenu subMenu = new JMenu("Insert");  
         menu.add(subMenu);
      
         JMenuItem menuItem = new JMenuItem("Delete");
         menuItem.addActionListener(m1);
         menu.add(menuItem);
      
         menuItem = new JMenuItem("Ball");
         menuItem.addActionListener(cl);
         subMenu.add(menuItem);
         menuItem = new JMenuItem("Wall Sideways");
         menuItem.addActionListener(cl);
         subMenu.add(menuItem);
         menuItem = new JMenuItem("Wall Straight");
         menuItem.addActionListener(cl);
         subMenu.add(menuItem);
      
         menuItem = new JMenuItem("Scenario");
         menuItem.addActionListener(cl);
         subMenu.add(menuItem);
      
         menu = new JMenu("MyWorld");
         mb.add(menu);
         menuItem = new JMenuItem("Start");
         menuItem.addActionListener(wl);
         menu.add(menuItem);
         menuItem = new JMenuItem("Stop");
         menuItem.addActionListener(wl);
         menu.add(menuItem);
         menuItem = new JMenuItem("Gravity");
         menuItem.addActionListener(wl);
         menu.add(menuItem);
         menuItem = new JMenuItem("Viscosity");
         menuItem.addActionListener(wl);
         menu.add(menuItem);
         subMenu = new JMenu("Simulator");
         menu.add(subMenu);
         menuItem = new JMenuItem("Delta time");
         menuItem.addActionListener(wl);
         subMenu.add(menuItem);
         menuItem = new JMenuItem("Graphics Refresh time");
         menuItem.addActionListener(wl);
         subMenu.add(menuItem);
			subMenu = new JMenu("Energy Plot");                 //Se agregan las entradas
			menu.add(subMenu);                                  //de menú "Energy Plot"
			menuItem = new JMenuItem("ON");
			menuItem.addActionListener(fc);
			subMenu.add(menuItem);
			menuItem = new JMenuItem("OFF");
			menuItem.addActionListener(fc);
			subMenu.add(menuItem);

         return mb;          
      }   
   }

